<?php

/**
 * inf_versiones_ep actions.
 *
 * @package    contratacion
 * @subpackage inf_versiones_ep
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_versiones_epActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.id_anhos,tab0.valor,tab0.id_area,tab0.responsable,tab0.id_supervisor,tab0.fecha_creacion,tab0.version';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */



            /*
             * Variables opcionales
             */



            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);


            $id_anhos = $request['id_anhos'];

            $whereAbogado = "";
            $whereModalidad = "";
            $whereProceso = "";
            $whereResponsable = "";
            $whereArea = "";
            $whereSupervisor = "";


            if (isset($request['id_abogado'])) {
                $whereAbogado = " AND tab0.id_abogado=" . $request['id_abogado'];
            }

            if (isset($request['id_area'])) {
                $whereArea = " AND tab0.id_area=" . $request['id_area'];
            }

            if (isset($request['id_modalidad_sel'])) {
                $whereModalidad = " AND tab0.id_modalidad_sel=" . $request['id_modalidad_sel'];
            }

            if (isset($request['no_proceso'])) {
                $whereProceso = " AND tab0.no_proceso=" . $request['no_proceso'];
            }

            if (isset($request['responsable'])) {
                $whereResponsable = " AND tab0.responsable=" . $request['responsable'];
            }

            if (isset($request['id_supervisor'])) {
                $whereSupervisor = " AND tab0.id_supervisor=" . $request['id_supervisor'];
            }

            /*
             * 
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
        select count(*) as count from (

            select tab0.*,tab1.RAZON_SOC AS USUARIO_VERSION,
            case when tab1.fecha_creacion is null then tab0.fecha_creacion else tab1.FECHA_CREACION end AS FECHA_VERSION
            from CO_ESTUDIOS_PREVIOS_V tab0
            left join CO_VERSIONES_EP_V tab1 ON tab1.ID_VERSION_PADRE = tab0.ID_ESTUDIOS_PREVIOS

            where tab0.id_anhos = $id_anhos

            $whereAbogado
            $whereModalidad
            $whereProceso
            $whereResponsable
            $whereArea
            $whereSupervisor

            $sortBy                    
        
        )
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select tab0.*,tab1.RAZON_SOC AS USUARIO_VERSION,tab1.FECHA_CREACION AS FECHA_VERSION

from CO_ESTUDIOS_PREVIOS_V tab0
left join CO_VERSIONES_EP_V tab1 ON tab1.ID_VERSION_PADRE = tab0.ID_ESTUDIOS_PREVIOS

where tab0.id_anhos = $id_anhos

$whereAbogado
$whereModalidad
$whereProceso
$whereResponsable
$whereArea
$whereSupervisor

$sortBy       
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_versiones_ep] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
